
#property copyright "Test"
#property link "http://www.test.com"
#include <stdlib.mqh>

//+------------------------------------------------------------------+
extern int Secend = 3600;
//extern int Secend = 300;
extern double Lot = 1;
extern double SL = 10;
extern double TP = 5;
extern double Slippage_Open = 1;
extern double Slippage_Close = 1;
extern string Comments = "example";
extern int MagicNumber = 123456;
//+------------------------------------------------------------------+
int init()
{

return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//----

//----
return(0);
}

//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+
int start()
{


closeOrders(OP_BUY,PERIOD_H1);
closeOrders(OP_SELL,PERIOD_H1);
//----
int Last_openorder_time = Secend+1 ;
int Last_historyorder_time = Secend+1;

if(OrdersTotal() > 0 )
{
OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES);
Last_openorder_time = TimeCurrent() - OrderOpenTime();
if( Last_openorder_time > Secend )
{
GetOrder ( "buy" ) ; return(0);
}
}

else if( OrdersHistoryTotal() > 0 )
{
OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY);
Last_historyorder_time = TimeCurrent() - OrderOpenTime();
if( Last_historyorder_time > Secend )
{
GetOrder ( "buy" ) ; return(0);
}
}

//
//
//
// no opened orders yet, open the first order
//
//

else GetOrder ( "buy" );

//----
return(0);
}


//====================================== Send Order ===========================================


int GetOrder(string cmd)
{
double stoploss =0;
double takeprofit =0;

int Ticket=0;
int lastError=0;

//
//
// pip multiplier needed for 5 digit brokers to convert point into pips
//
//

int pipMultiplier = 1;
if (Digits==3 || Digits==5) pipMultiplier=10;

if(cmd == "buy")
{
if(TP == 0 ) takeprofit = 0;
else takeprofit = MarketInfo(Symbol(),MODE_ASK) + TP * Point*pipMultiplier;
if(SL == 0 ) stoploss = 0;
else stoploss = MarketInfo(Symbol(),MODE_ASK) - SL * Point*pipMultiplier;

Print("Buy Order Sent With: Symbol=", Symbol(), " Lot=", Lot, " Price=", MarketInfo(Symbol(),MODE_ASK));
Ticket = OrderSend(Symbol(), OP_BUY, Lot, MarketInfo(Symbol(),MODE_ASK), Slippage_Open, stoploss, takeprofit, Comments, MagicNumber, 0, Blue);
if (Ticket < 0)
{
lastError = GetLastError(); // save last error because GetLastError() clears the error number and than you do not
// know what the error code was when calling ErrorDescription() function
Print("OrderSend failed with error #", lastError, " ", ErrorDescription(lastError));
}
}
else if(cmd == "sell")
{
if(TP == 0 ) takeprofit = 0;
else takeprofit = MarketInfo(Symbol(),MODE_BID) - TP * Point*pipMultiplier;
if(SL == 0 ) stoploss = 0;
else stoploss = MarketInfo(Symbol(),MODE_BID) + SL * Point*pipMultiplier;

Print("Sell Order Sent With: Symbol=", Symbol(), " Lot=", Lot, " Price=", MarketInfo(Symbol(),MODE_BID));
Ticket = OrderSend(Symbol(), OP_SELL, Lot, MarketInfo(Symbol(),MODE_BID), Slippage_Open, stoploss, takeprofit, Comments, MagicNumber, 0, Blue);
if (Ticket < 0)
{
lastError = GetLastError();
Print("OrderSend failed with error #", lastError, " ", ErrorDescription(lastError));
}
}
return (Ticket);

}

void closeOrders(int orderType, int timeFrameToCheck)
{
for(int i=OrdersTotal()-1; i>=0; i--)
{
if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES)==false) break;
if(OrderMagicNumber() != MagicNumber) continue;
if(OrderType() != orderType) continue;
if(OrderSymbol() != Symbol()) continue;

//
//
//
// check if order has to be closed at all
// it is checking the target time frame (use PERIOD_H1 in timeFrameToCheck
// if you want to close an order after 1 hour bar has expired)
//
//
//

int y = iBarShift(Symbol(),timeFrameToCheck,OrderOpenTime( )); // target time frame bar of the order open time
int c = iBarShift(Symbol(),timeFrameToCheck,Time[0]); // target time frame bar of the current bar

if (y<=c) continue; // if the bar is lees (opened after - in some errors case)
// or the bar is the same, no need to close this opened order

//
//
//
//
//

RefreshRates();
switch(orderType)
{
case OP_BUY : OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); break;
case OP_SELL : OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); break;
}
}
}



